Bug 563927 - Potential for deadlock when snapshots are taken of mirrors
Summary: Potential for deadlock when snapshots are taken of mirrors
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 6
Classification: Red Hat
Component: lvm2
Version: 6.0
Hardware: All
OS: Linux
low
medium
Target Milestone: rc
: ---
Assignee: Jonathan Earl Brassow
QA Contact: Corey Marthaler
URL:
Whiteboard:
Depends On: 563924
Blocks: 756082
TreeView+ depends on / blocked
 
Reported: 2010-02-11 15:32 UTC by Jonathan Earl Brassow
Modified: 2013-02-21 08:07 UTC (History)
8 users (show)

Fixed In Version:
Doc Type: Known Issue
Doc Text:
Known Issue: Due to the limitations of the LVM 'mirror' segment type, it is possible to encounter a deadlock situation when snapshots are created of mirrors. The deadlock can occur if snapshot changes (e.g. creation, resizing or removing) happen at the same time as a mirror device failure. In this case, the mirror blocks I/O until LVM can respond to the failure, but the snapshot is holding the LVM lock while trying to read the mirror. If the user wishes to use mirroring and take snapshots of those mirrors, then it is recommended to use the 'raid1' segment type for the mirrored logical volume instead. This can be done by adding the additional arguments '--type raid1' to the command that creates the mirrored logical volume, as follows: ~> lvcreate --type raid1 -m 1 -L 1G -n my_mirror my_vg
Clone Of: 563924
Environment:
Last Closed: 2013-02-21 08:07:35 UTC


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHBA-2013:0501 normal SHIPPED_LIVE lvm2 bug fix and enhancement update 2013-02-20 21:30:45 UTC

Comment 8 Jonathan Earl Brassow 2012-10-15 17:11:01 UTC
This bug will never be completely fixed WRT the 'mirror' segment type and snapshots.  However, 'raid1' can be used in place of 'mirror' and does not suffer from this issue.

Thus, this becomes a documentation and awareness issue.  I am marking this bug as MODIFIED, although that is not technically correct.  I don't want to CLOSE the bug without the release note stating that users should use the alternative.

It could be argued that LVM should warn users if snapshots are attempted on 'mirror's and suggest 'raid1' instead...

Comment 12 Peter Rajnoha 2012-10-19 11:46:12 UTC
Doc only bug, this should appear as a "Known Issue" item in the 6.4 documentation.

Comment 16 errata-xmlrpc 2013-02-21 08:07:35 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

http://rhn.redhat.com/errata/RHBA-2013-0501.html


Note You need to log in before you can comment on or make changes to this bug.